/**
* Source File Name:   eurodesktoprechner.java
* Author: Ernst-Nikolaus Satvanyi
*/

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.DecimalFormat;
import java.text.NumberFormat;

public class eurodesktoprechner extends Panel
    implements ActionListener
{
    boolean neue_Zahl;
    boolean Vorkomma;
    String akt_Text;
    TextField AnzIn;
    TextField AnzOut;
    boolean ist_berechnet;
    String string_in;
    String string_out;
    double ZahlIn;
    double ZahlOut;
    double ZahlEuro;
    double ZahlOutRund;
    private DecimalFormat df;
    double euro;
    final double euro_iep = 0.787564;
    final double euro_nlg = 2.20371;
    final double euro_bef = 40.3399;
    final double euro_frf = 6.55957;
    final double euro_itl = 1936.27;
    final double euro_ats = 13.7603;
    final double euro_esp = 166.386;
    final double euro_pte = 200.482;
    final double euro_fim = 5.94573;
    final double euro_luf = 40.3399;
    final double euro_dem = 1.95583;
    Choice waehrung_in;
    Choice waehrung_out;

    public eurodesktoprechner()
    {
        neue_Zahl = true;
        Vorkomma = true;
        ist_berechnet = false;
        ZahlIn = 0.0;
        ZahlOut = 0.0;
        ZahlEuro = 0.0;
        ZahlOutRund = 0.0;
        df = new DecimalFormat("##0.0#");
        euro = 0.0;
        waehrung_in = new Choice();
        waehrung_out = new Choice();
        setBackground(Color.lightGray);
        setLayout(new BorderLayout());
        Panel panel = new Panel();
        Panel panel1 = new Panel();
        Panel panel2 = new Panel();
        panel.add(new Label(""));
        add("East", panel);
        panel1.setLayout(new GridLayout(13, 1, 10, 5));
        AnzIn = new TextField(30);
        AnzIn.setEditable(false);
        AnzIn.setText("0.0");
        AnzIn.setBackground(Color.white);
        waehrung_in.setBackground(Color.white);
        AnzOut = new TextField(30);
        AnzOut.setEditable(false);
        AnzOut.setText("0.0");
        AnzOut.setBackground(Color.yellow);
        waehrung_out.setBackground(Color.yellow);
        Font font = new Font("Serif", 1, 12);
        Button button = new Button("0");
        Button button1 = new Button("1");
        Button button2 = new Button("2");
        Button button3 = new Button("3");
        Button button4 = new Button("4");
        Button button5 = new Button("5");
        Button button6 = new Button("6");
        Button button7 = new Button("7");
        Button button8 = new Button("8");
        Button button9 = new Button("9");
        Button button10 = new Button("C");
        Button button11 = new Button(".");
        Button button12 = new Button("<-");
        Button button13 = new Button("=");
        Panel panel3 = new Panel();
        Panel panel4 = new Panel();
        Panel panel5 = new Panel();
        Panel panel6 = new Panel();
        Panel panel7 = new Panel();
        Panel panel8 = new Panel();
        Panel panel9 = new Panel();
        Panel panel10 = new Panel();
        Panel panel11 = new Panel();
        panel4.setFont(font);
        panel11.setFont(font);
        GridLayout gridlayout = new GridLayout(1, 2, 10, 5);
        GridLayout gridlayout1 = new GridLayout(1, 3, 10, 5);
        panel3.setLayout(gridlayout);
        panel4.setLayout(gridlayout);
        panel5.setLayout(gridlayout1);
        panel6.setLayout(gridlayout1);
        panel7.setLayout(gridlayout1);
        panel8.setLayout(gridlayout1);
        panel9.setLayout(gridlayout1);
        panel10.setLayout(gridlayout);
        panel11.setLayout(gridlayout);
        panel1.add(new Label(""));
        panel3.add(new Label("Input:"));
        panel3.add(new Label("Currency:"));
        panel4.add(AnzIn);
        panel4.add(waehrung_in);
        waehrung_in.addItem("ATS");
        waehrung_in.addItem("BEF");
        waehrung_in.addItem("DEM");
        waehrung_in.addItem("ESP");
        waehrung_in.addItem("EUR");
        waehrung_in.addItem("FIM");
        waehrung_in.addItem("FRF");
        waehrung_in.addItem("IEP");
        waehrung_in.addItem("ITL");
        waehrung_in.addItem("LUF");
        waehrung_in.addItem("NLG");
        waehrung_in.addItem("PTE");
        panel5.add(button7);
        panel5.add(button8);
        panel5.add(button9);
        panel6.add(button4);
        panel6.add(button5);
        panel6.add(button6);
        panel7.add(button1);
        panel7.add(button2);
        panel7.add(button3);
        panel8.add(button);
        panel8.add(button11);
        panel8.add(button12);
        panel9.add(button10);
        panel9.add(new Label(""));
        panel9.add(button13);
        panel1.add(panel3);
        panel1.add(panel4);
        panel1.add(new Label(""));
        panel1.add(panel5);
        panel1.add(panel6);
        panel1.add(panel7);
        panel1.add(panel8);
        panel1.add(panel9);
        panel1.add(new Label(""));
        panel10.add(new Label("Output:"));
        panel10.add(new Label("Currency:"));
        panel1.add(panel10);
        waehrung_out.addItem("ATS");
        waehrung_out.addItem("BEF");
        waehrung_out.addItem("DEM");
        waehrung_out.addItem("ESP");
        waehrung_out.addItem("EUR");
        waehrung_out.addItem("FIM");
        waehrung_out.addItem("FRF");
        waehrung_out.addItem("IEP");
        waehrung_out.addItem("ITL");
        waehrung_out.addItem("LUF");
        waehrung_out.addItem("NLG");
        waehrung_out.addItem("PTE");
        panel11.add(AnzOut);
        panel11.add(waehrung_out);
        panel1.add(panel11);
        panel1.add(new Label(""));
        add("Center", panel1);
        panel2.add(new Label(""));
        add("West", panel2);
        button.addActionListener(this);
        button1.addActionListener(this);
        button2.addActionListener(this);
        button3.addActionListener(this);
        button4.addActionListener(this);
        button5.addActionListener(this);
        button6.addActionListener(this);
        button7.addActionListener(this);
        button8.addActionListener(this);
        button9.addActionListener(this);
        button10.addActionListener(this);
        button12.addActionListener(this);
        button11.addActionListener(this);
        button13.addActionListener(this);
    }

    public void Berechnung_ausfuehren()
    {
        ZahlIn = Double.valueOf(AnzIn.getText()).doubleValue();
        ZahlEuro = 0.0;
        ZahlOutRund = 0.0;
        ZahlOut = 0.0;
        if(string_in == "EUR")
        {
            ZahlEuro = ZahlIn;
            if(string_out == "ATS")
            {
                ZahlOut = ZahlEuro * 13.7603;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "BEF")
            {
                ZahlOut = ZahlEuro * 40.3399;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "DEM")
            {
                ZahlOut = ZahlEuro * 1.95583;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "ESP")
            {
                ZahlOut = ZahlEuro * 166.386D;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "FIM")
            {
                ZahlOut = ZahlEuro * 5.94573;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "FRF")
            {
                ZahlOut = ZahlEuro * 6.55957;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "IEP")
            {
                ZahlOut = ZahlEuro * 0.787564;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "ITL")
            {
                ZahlOut = ZahlEuro * 1936.27;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "LUF")
            {
                ZahlOut = ZahlEuro * 40.3399;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "NLG")
            {
                ZahlOut = ZahlEuro * 2.20371;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_out == "PTE")
            {
                ZahlOut = ZahlEuro * 200.482;
                ZahlOutRund = runden2(ZahlOut);
            }
            AnzOut.setText(df.format(ZahlOutRund));
        }
        if(string_out == "EUR")
        {
            ZahlEuro = ZahlIn;
            if(string_in == "ATS")
            {
                ZahlOut = ZahlEuro / 13.7603;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "BEF")
            {
                ZahlOut = ZahlEuro / 40.3399;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "DEM")
            {
                ZahlOut = ZahlEuro / 1.95583;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "ESP")
            {
                ZahlOut = ZahlEuro / 166.386;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "FIM")
            {
                ZahlOut = ZahlEuro / 5.94573;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "FRF")
            {
                ZahlOut = ZahlEuro / 6.55957;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "IEP")
            {
                ZahlOut = ZahlEuro / 0.787564;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "ITL")
            {
                ZahlOut = ZahlEuro / 1936.27;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "LUF")
            {
                ZahlOut = ZahlEuro / 40.3399;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "NLG")
            {
                ZahlOut = ZahlEuro / 2.20371;
                ZahlOutRund = runden2(ZahlOut);
            }
            if(string_in == "PTE")
            {
                ZahlOut = ZahlEuro / 200.482;
                ZahlOutRund = runden2(ZahlOut);
            }
            AnzOut.setText(df.format(ZahlOutRund));
        }
        if(string_in != "EUR" && string_out != "EUR")
        {
            if(string_in == "ATS")
            {
                euro = ZahlIn / 13.7603;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "BEF")
            {
                euro = ZahlIn / 40.3399;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "DEM")
            {
                euro = ZahlIn / 1.95583;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "ESP")
            {
                euro = ZahlIn / 166.386;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "FIM")
            {
                euro = ZahlIn / 5.94573;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "FRF")
            {
                euro = ZahlIn / 6.55957;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "IEP")
            {
                euro = ZahlIn / 0.787564;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "ITL")
            {
                euro = ZahlIn / 1936.27;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "LUF")
            {
                euro = ZahlIn / 40.3399;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "NLG")
            {
                euro = ZahlIn / 2.20371;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            if(string_in == "PTE")
            {
                euro = ZahlIn / 200.482;
                ZahlEuro = runden3(euro);
                ausgabe();
            }
            AnzOut.setText(df.format(ZahlOutRund));
        }
    }

    public void actionPerformed(ActionEvent actionevent)
    {
        boolean flag = false;
        boolean flag1 = false;
        String s = actionevent.getActionCommand();
        if(s.equals("<-"))
        {
            ist_berechnet = false;
            akt_Text = AnzIn.getText();
            boolean flag2 = akt_Text.endsWith(".");
            if(flag2)
            {
                Vorkomma = true;
                boolean flag3 = false;
            }
            int i = akt_Text.length() - 1;
            String s1 = akt_Text.substring(0, i);
            AnzIn.setText(s1);
            return;
        }
        char c = s.charAt(0);
        switch(c)
        {
        case 67: // 'C'
            AnzIn.setText("0.0");
            AnzOut.setText("0.0");
            Vorkomma = true;
            neue_Zahl = true;
            ist_berechnet = false;
            break;

        case 61: // '='
            string_in = waehrung_in.getSelectedItem();
            string_out = waehrung_out.getSelectedItem();
            neue_Zahl = true;
            Vorkomma = true;
            ist_berechnet = true;
            akt_Text = AnzIn.getText();
            boolean flag4 = akt_Text.endsWith(".");
            if(flag4)
            {
                akt_Text = akt_Text + "00";
                boolean flag5 = false;
            }
            if(string_in.equals(string_out))
            {
                euro = 0.0;
                euro = Double.valueOf(AnzIn.getText()).doubleValue();
                AnzOut.setText(df.format(euro));
            } else
            {
                Berechnung_ausfuehren();
            }
            break;

        case 46: // '.'
            if(!ist_berechnet)
            {
                if(neue_Zahl)
                {
                    AnzIn.setText("0");
                    neue_Zahl = false;
                }
                if(Vorkomma)
                {
                    Vorkomma = false;
                    akt_Text = AnzIn.getText();
                    akt_Text += 46;
                    AnzIn.setText(akt_Text);
                }
            } else
            {
                return;
            }
            break;

        default:
            ist_berechnet = false;
            if(neue_Zahl)
            {
                AnzIn.setText("");
                AnzOut.setText("");
                neue_Zahl = false;
            }
            akt_Text = AnzIn.getText();
            AnzIn.setText(akt_Text + c);
            break;
        }
    }

    public void ausgabe()
    {
        ZahlOut = 0.0;
        ZahlOutRund = 0.0;
        if(string_out == "ATS")
        {
            ZahlOut = ZahlEuro * 13.7603;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "BEF")
        {
            ZahlOut = ZahlEuro * 40.3399;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "DEM")
        {
            ZahlOut = ZahlEuro * 1.95583;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "ESP")
        {
            ZahlOut = ZahlEuro * 166.386;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "FIM")
        {
            ZahlOut = ZahlEuro * 5.94573;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "FRF")
        {
            ZahlOut = ZahlEuro * 6.55957;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "IEP")
        {
            ZahlOut = ZahlEuro * 0.787564;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "ITL")
        {
            ZahlOut = ZahlEuro * 1936.27;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "LUF")
        {
            ZahlOut = ZahlEuro * 40.3399;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "NLG")
        {
            ZahlOut = ZahlEuro * 2.20371;
            ZahlOutRund = runden2(ZahlOut);
        }
        if(string_out == "PTE")
        {
            ZahlOut = ZahlEuro * 200.482;
            ZahlOutRund = runden2(ZahlOut);
        }
    }

    public Dimension getMinimuSize()
    {
        return getPreferredSize();
    }

    public Dimension getPreferredSize()
    {
        return new Dimension(450, 300);
    }

    public double runden2(double d)
    {
        double d1 = 0.0;
        double d2 = 0.0;
        double d3 = 0.0;
        d1 = Math.floor(d);
        d2 = d - d1;
        d3 = Math.round(100 * d2);
        return d1 + d3 * 0.01;
    }

    public double runden3(double d)
    {
        double d1 = 0.0;
        double d2 = 0.0;
        double d3 = 0.0;
        d1 = Math.floor(d);
        d2 = d - d1;
        d3 = Math.round(1000 * d2);
        return d1 + 0.001 * d3;
    }
}
